<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'ByIndustrySolutionsBlock',
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
    offset: {
      type: Number,
      required: false,
      default: 0,
    },
  },
  data() {
    return {
      PageProgress: 8,
    };
  },
  computed: {
    applyPercent() {
      return this.PageProgress;
    },
  },
  mounted() {
    window.addEventListener('scroll', this.updatePageProgress);

    window.addEventListener('load', () => {
      const children = document.getElementById(
        'solutions-block__parentContainer',
      )?.children;

      const observer = new IntersectionObserver(
        (entries) => {
          entries.forEach((entry) => {
            entry.target.classList.toggle(
              'scroll-solutions__active-section',
              entry.isIntersecting,
            );
            entry.target.setAttribute(
              'aria-disabled',
              entry.target.ariaDisabled ? 'true' : 'false',
            );
          });
        },
        {
          threshold: 0.4,
          rootMargin: '-120px',
        },
      );

      for (let i = 0; i < children?.length; i++) {
        observer.observe(children[i]);
      }
    });
  },
  destroyed() {
    window.removeEventListener('scroll', this.updatePageProgress);
  },
  methods: {
    getElementDistance(elem) {
      let location = 0;
      if (elem.offsetParent) {
        do {
          location += elem.offsetTop;
          // eslint-disable-next-line
          elem = elem.offsetParent;
        } while (elem);
      }
      return location >= 0 ? location : 0;
    },

    updatePageProgress() {
      const elem = document.getElementById('scroll-solutions');
      // above line makes it so that you can only have this component once per page
      const elementDistanceFromTop = this.getElementDistance(elem);
      const currentPosition = window.pageYOffset;
      const elementHeight =
        document.getElementById('scroll-solutions')?.clientHeight;

      if (
        elementDistanceFromTop < currentPosition + 120 && // 120px is the height of the navigation
        currentPosition < elementDistanceFromTop + elementHeight
      ) {
        const percent =
          ((currentPosition - elementDistanceFromTop) / elementHeight) * 100 +
          15;
        if (percent > 100) {
          this.PageProgress = 100;
        } else {
          this.PageProgress = percent;
        }
      }
    },
  },
});
</script>

<template>
  <div
    id="solutions-block"
    class="solutions-block"
    :class="{ 'solutions-block--white-bg': data.white_bg }"
  >
    <SlpContainer class="solutions-block__container">
      <SlpRow>
        <SlpColumn v-if="offset !== 0" :cols="offset" />
        <SlpColumn :cols="8">
          <SlpTypography tag="h2" variant="heading2-bold" class="slp-mb-16"
            >{{ data.subtitle }}
          </SlpTypography>

          <SlpTypography
            v-if="data.sub_description"
            tag="p"
            variant="body1"
            class="slp-mb-96"
            >{{ data.sub_description }}
          </SlpTypography>
        </SlpColumn>
      </SlpRow>
      <div id="scroll-solutions" class="scroll-solutions">
        <SlpColumn v-if="offset !== 0" :cols="offset" />
        <SlpColumn :cols="1">
          <div class="progress-container">
            <div
              class="progress-bar"
              :style="{ height: `${PageProgress}%` }"
            ></div>
          </div>
        </SlpColumn>
        <SlpColumn
          id="solutions-block__parentContainer"
          :cols="5"
          class="scroll-solutions__col slp-align-items-center"
        >
          <div
            v-for="(solution, index) in data.solutions"
            :id="index"
            :key="index"
            class="scroll-solutions__info"
          >
            <SlpIcon
              v-if="solution.icon"
              :name="solution.icon.name"
              :alt="solution.icon.alt"
              :variant="solution.icon.variant"
              size="md"
            />
            <SlpTypography tag="h3" variant="heading3-bold" class="slp-my-8"
              >{{ solution.title }}
            </SlpTypography>
            <div
              v-html="
                data.markdown
                  ? $md.render(solution.description)
                  : solution.description
              "
            />
            <SlpButton
              v-if="solution.link_text"
              :href="solution.link_url"
              variant="ghost"
              class="slp-mt-32"
              :aria-label="solution.data_ga_name"
              :data-ga-name="solution.data_ga_name"
              :data-ga-location="solution.data_ga_location"
              >{{ solution.link_text }}
              <SlpIcon name="chevron-lg-right" variant="product" />
            </SlpButton>
          </div>
        </SlpColumn>
        <SlpColumn :cols="4" class="scroll-solutions__img-col">
          <nuxt-img
            class="scroll-solutions__img"
            :src="data.sub_image"
            alt=""
            loading="lazy"
          />
        </SlpColumn>
      </div>
    </SlpContainer>
  </div>
</template>

<style scoped lang="scss">
.solutions-block {
  background: $color-surface-800;
  position: relative;
  padding: 160px 0;

  @media (max-width: $breakpoint-md) {
    padding: $spacing-48 0;
  }

  &__container {
    margin-bottom: $spacing-96;

    @media (max-width: $breakpoint-md) {
      padding: 0 $spacing-16;
    }
  }

  &--white-bg {
    background: none;
  }

  .scroll-solutions__img {
    max-width: 100%;
  }
}

.scroll-solutions {
  display: flex;
  flex-wrap: wrap;
  position: relative;
  transition: opacity 0.2s;

  &__col div {
    max-width: 350px;
  }

  &__info:not(:last-child) {
    padding-bottom: $spacing-96;

    @media (max-width: $breakpoint-md) {
      height: auto;
      margin-bottom: $spacing-64;
    }
  }

  &__info {
    opacity: 0.6;
    transition: opacity 0.2s;

    @media (max-width: $breakpoint-md) {
      padding: 0 $spacing-16 0 $spacing-64;
    }

    img {
      max-width: $spacing-32;
    }
  }

  &__img-col {
    img {
      position: sticky;
      top: 160px;
    }

    @media (max-width: $breakpoint-md) {
      display: none;
    }
  }
}

.scroll-solutions__active-section {
  opacity: 1;
}

.progress-container {
  width: 2px;
  background: $color-surface-200;
  position: absolute;
  top: 0;
  bottom: 0;
  left: 0;
}

.progress-bar {
  position: absolute;
  background: $color-surface-700;
  width: 2px;
}

.solutions-block__header {
  margin: $spacing-96 auto;

  img {
    width: 100%;
  }

  h2,
  p {
    width: 380px;
  }

  p {
    float: right;
  }

  .solutions-block__text-container {
    width: 100%;
  }
}

.slp-btn {
  color: $color-text-300;
}

.slp-text-button,
.slp-btn-ghost {
  font-weight: 600;
  padding-left: 0;
}

.slp-btn .slp-icon,
.solutions-block__link .slp-icon {
  vertical-align: middle;
  margin-left: $spacing-4;
}
</style>
